/**
 * Copyright: Copyright (c) 2008 Jacob Carlborg. All rights reserved.
 * Authors: Jacob Carlborg
 * Version: Initial created: Nov 18, 2008
 * License: $(LINK2 http://opensource.org/licenses/bsd-license.php, BSD Style)
 * 
 */
module dwt.internal.objc.cocoa.Cocoa;

import tango.stdc.config;
import bindings = dwt.internal.objc.cocoa.bindings;
import dwt.internal.objc.runtime;

extern (C)
{
    // *.h
    extern
    {
        id NSAccessibilityButtonRole;
        id NSAccessibilityCheckBoxRole;
        id NSAccessibilityChildrenAttribute;
        id NSAccessibilityColumnRole;
        id NSAccessibilityComboBoxRole;
        id NSAccessibilityConfirmAction;
        id NSAccessibilityContentsAttribute;
        id NSAccessibilityDescriptionAttribute;
        id NSAccessibilityDialogSubrole;
        id NSAccessibilityEnabledAttribute;
        id NSAccessibilityExpandedAttribute;
        id NSAccessibilityFloatingWindowSubrole;
        id NSAccessibilityFocusedAttribute;
        id NSAccessibilityFocusedUIElementChangedNotification;
        id NSAccessibilityGridRole;
        id NSAccessibilityGroupRole;
        id NSAccessibilityHelpAttribute;
        id NSAccessibilityHelpTagRole;
        id NSAccessibilityHorizontalOrientationValue;
        id NSAccessibilityHorizontalScrollBarAttribute;
        id NSAccessibilityImageRole;
        id NSAccessibilityIncrementorRole;
        id NSAccessibilityInsertionPointLineNumberAttribute;
        id NSAccessibilityLabelValueAttribute;
        id NSAccessibilityLineForIndexParameterizedAttribute;
        id NSAccessibilityLinkRole;
        id NSAccessibilityLinkTextAttribute;
        id NSAccessibilityListRole;
        id NSAccessibilityMaxValueAttribute;
        id NSAccessibilityMenuBarRole;
        id NSAccessibilityMenuButtonRole;
        id NSAccessibilityMenuItemRole;
        id NSAccessibilityMenuRole;
        id NSAccessibilityMinValueAttribute;
        id NSAccessibilityNextContentsAttribute;
        id NSAccessibilityNumberOfCharactersAttribute;
        id NSAccessibilityOrientationAttribute;
        id NSAccessibilityOutlineRole;
        id NSAccessibilityOutlineRowSubrole;
        id NSAccessibilityParentAttribute;
        id NSAccessibilityPopUpButtonRole;
        id NSAccessibilityPositionAttribute;
        id NSAccessibilityPressAction;
        id NSAccessibilityPreviousContentsAttribute;
        id NSAccessibilityProgressIndicatorRole;
        id NSAccessibilityRTFForRangeParameterizedAttribute;
        id NSAccessibilityRadioButtonRole;
        id NSAccessibilityRadioGroupRole;
        id NSAccessibilityRangeForIndexParameterizedAttribute;
        id NSAccessibilityRangeForLineParameterizedAttribute;
        id NSAccessibilityRangeForPositionParameterizedAttribute;
        id NSAccessibilityRoleAttribute;
        id NSAccessibilityRoleDescriptionAttribute;
        id NSAccessibilityRowRole;
        id NSAccessibilityScrollAreaRole;
        id NSAccessibilityScrollBarRole;
        id NSAccessibilitySelectedAttribute;
        id NSAccessibilitySelectedChildrenAttribute;
        id NSAccessibilitySelectedChildrenChangedNotification;
        id NSAccessibilitySelectedTextAttribute;
        id NSAccessibilitySelectedTextChangedNotification;
        id NSAccessibilitySelectedTextRangeAttribute;
        id NSAccessibilitySelectedTextRangesAttribute;
        id NSAccessibilitySizeAttribute;
        id NSAccessibilitySliderRole;
        id NSAccessibilitySortButtonRole;
        id NSAccessibilitySplitterRole;
        id NSAccessibilityStandardWindowSubrole;
        id NSAccessibilityStaticTextRole;
        id NSAccessibilityStringForRangeParameterizedAttribute;
        id NSAccessibilityStyleRangeForIndexParameterizedAttribute;
        id NSAccessibilitySubroleAttribute;
        id NSAccessibilitySystemDialogSubrole;
        id NSAccessibilityTabGroupRole;
        id NSAccessibilityTableRole;
        id NSAccessibilityTableRowSubrole;
        id NSAccessibilityTabsAttribute;
        id NSAccessibilityTextAreaRole;
        id NSAccessibilityTextFieldRole;
        id NSAccessibilityTextLinkSubrole;
        id NSAccessibilityTitleAttribute;
        id NSAccessibilityTitleUIElementAttribute;
        id NSAccessibilityToolbarRole;
        id NSAccessibilityTopLevelUIElementAttribute;
        id NSAccessibilityUnknownRole;
        id NSAccessibilityUnknownSubrole;
        id NSAccessibilityValueAttribute;
        id NSAccessibilityValueChangedNotification;
        id NSAccessibilityValueDescriptionAttribute;
        id NSAccessibilityValueIndicatorRole;
        id NSAccessibilityVerticalOrientationValue;
        id NSAccessibilityVerticalScrollBarAttribute;
        id NSAccessibilityVisibleCharacterRangeAttribute;
        id NSAccessibilityVisibleChildrenAttribute;
        id NSAccessibilityWindowAttribute;
        id NSAccessibilityWindowRole;
        id NSBackgroundColorAttributeName;
        id NSBaselineOffsetAttributeName;
        id NSCalibratedRGBColorSpace;
        id NSDeviceRGBColorSpace;
        id NSDeviceResolution;
        id NSDragPboard;
        id NSFilenamesPboardType;
        id NSFontAttributeName;
        id NSForegroundColorAttributeName;
        id NSHTMLPboardType;
        id NSLinkAttributeName;
        id NSParagraphStyleAttributeName;
        id NSPrintAllPages;
        id NSPrintCopies;
        id NSPrintFirstPage;
        id NSPrintJobDisposition;
        id NSPrintLastPage;
        id NSPrintMustCollate;
        id NSPrintPreviewJob;
        id NSPrintSaveJob;
        id NSPrintSavePath;
        id NSPrintSpoolJob;
        id NSRTFPboardType;
        id NSStrikethroughColorAttributeName;
        id NSStrikethroughStyleAttributeName;
        id NSStringPboardType;
        id NSTIFFPboardType;
        id NSURLPboardType;
        id NSUnderlineColorAttributeName;
        id NSUnderlineStyleAttributeName;
        id NSDefaultRunLoopMode;
        id NSErrorFailingURLStringKey;
    }
}




//NSAccessibility.h
alias bindings.NSAccessibilityActionDescription NSAccessibilityActionDescription;
alias bindings.NSAccessibilityPostNotification NSAccessibilityPostNotification;
alias bindings.NSAccessibilityRaiseBadArgumentException NSAccessibilityRaiseBadArgumentException;
alias bindings.NSAccessibilityRoleDescription NSAccessibilityRoleDescription;
alias bindings.NSAccessibilityRoleDescriptionForUIElement NSAccessibilityRoleDescriptionForUIElement;
alias bindings.NSAccessibilityUnignoredAncestor NSAccessibilityUnignoredAncestor;
alias bindings.NSAccessibilityUnignoredChildren NSAccessibilityUnignoredChildren;
alias bindings.NSAccessibilityUnignoredChildrenForOnlyChild NSAccessibilityUnignoredChildrenForOnlyChild;
alias bindings.NSAccessibilityUnignoredDescendant NSAccessibilityUnignoredDescendant;



// NSAlert.h
enum NSAlertStyle : NSUInteger
{
    NSWarningAlertStyle = 0,
    NSInformationalAlertStyle = 1,
    NSCriticalAlertStyle = 2
}



// NSApplication.h
enum NSApplicationTerminateReply
{
    NSTerminateCancel = 0,
    NSTerminateNow    = 1,
    NSTerminateLater  = 2
}



// NSBezierPath.h
enum NSBezierPathElement
{
    NSMoveToBezierPathElement,
    NSLineToBezierPathElement,
    NSCurveToBezierPathElement,
    NSClosePathBezierPathElement
}

enum NSLineCapStyle
{
    NSButtLineCapStyle = 0,
    NSRoundLineCapStyle = 1,
    NSSquareLineCapStyle = 2
}

enum NSLineJoinStyle
{
    NSMiterLineJoinStyle = 0,
    NSRoundLineJoinStyle = 1,
    NSBevelLineJoinStyle = 2
}

enum NSWindingRule
{
    NSNonZeroWindingRule = 0,
    NSEvenOddWindingRule = 1
}



// NSBox.h
enum NSTitlePosition
{
    NSNoTitle = 0,
    NSAboveTop = 1,
    NSAtTop = 2,
    NSBelowTop = 3,
    NSAboveBottom = 4,
    NSAtBottom = 5,
    NSBelowBottom = 6
}



// NSButtonCell.h
enum NSBezelStyle : NSUInteger {
    NSRoundedBezelStyle = 1,
    NSRegularSquareBezelStyle = 2,
    NSThickSquareBezelStyle = 3,
    NSThickerSquareBezelStyle = 4,
    NSDisclosureBezelStyle = 5,
    NSShadowlessSquareBezelStyle = 6,
    NSCircularBezelStyle = 7,
    NSTexturedSquareBezelStyle = 8,
    NSHelpButtonBezelStyle = 9,
    NSSmallSquareBezelStyle = 10,
    NSTexturedRoundedBezelStyle = 11,
    NSRoundRectBezelStyle = 12,
    NSRecessedBezelStyle = 13,
    NSRoundedDisclosureBezelStyle = 14,
}

enum NSButtonType : NSUInteger {
    NSMomentaryLightButton = 0,
    NSPushOnPushOffButton = 1,
    NSToggleButton = 2,
    NSSwitchButton = 3,
    NSRadioButton = 4,
    NSMomentaryChangeButton = 5,
    NSOnOffButton = 6,
    NSMomentaryPushInButton = 7,
    NSMomentaryPushButton = 0,
    NSMomentaryLight = 7
}



// NSCell.h
enum NSControlSize : NSUInteger
{
    NSRegularControlSize,
    NSSmallControlSize,
    NSMiniControlSize
}

enum NSImageScaling : NSUInteger
{
    NSImageScaleProportionallyDown = 0,
    NSImageScaleAxesIndependently,
    NSImageScaleNone,
    NSImageScaleProportionallyUpOrDown
}

enum NSCellImagePosition : NSUInteger
{
    NSNoImage       = 0,
    NSImageOnly     = 1,
    NSImageLeft     = 2,
    NSImageRight    = 3,
    NSImageBelow    = 4,
    NSImageAbove    = 5,
    NSImageOverlaps = 6
}



// NSDragging.h
enum NSDragOperation : uint
{
    NSDragOperationNone = 0,
    NSDragOperationCopy = 1,
    NSDragOperationLink = 2,
    NSDragOperationGeneric = 4,
    NSDragOperationPrivate = 8,
    NSDragOperationAll_Obsolete = 15,
    NSDragOperationMove = 16,
    NSDragOperationDelete = 32,
    NSDragOperationEvery = uint.max // UINT_MAX
}



// NSEvent.h
enum NSEventType
{
    NSLeftMouseDown      = 1,
    NSLeftMouseUp        = 2,
    NSRightMouseDown     = 3,
    NSRightMouseUp       = 4,
    NSMouseMoved         = 5,
    NSLeftMouseDragged   = 6,
    NSRightMouseDragged  = 7,
    NSMouseEntered       = 8,
    NSMouseExited        = 9,
    NSKeyDown            = 10,
    NSKeyUp              = 11,
    NSFlagsChanged       = 12,
    NSAppKitDefined      = 13,
    NSSystemDefined      = 14,
    NSApplicationDefined = 15,
    NSPeriodic           = 16,
    NSCursorUpdate       = 17,
    NSScrollWheel        = 22,
    NSTabletPoint        = 23,
    NSTabletProximity    = 24,
    NSOtherMouseDown     = 25,
    NSOtherMouseUp       = 26,
    NSOtherMouseDragged  = 27
}



// NSGraphics.h
alias int NSWindowDepth;

alias bindings.NSBeep NSBeep;
alias bindings.NSBitsPerPixelFromDepth NSBitsPerPixelFromDepth;

enum NSCompositingOperation
{
    NSCompositeClear = 0,
    NSCompositeCopy = 1,
    NSCompositeSourceOver = 2,
    NSCompositeSourceIn = 3,
    NSCompositeSourceOut = 4,
    NSCompositeSourceAtop = 5,
    NSCompositeDestinationOver = 6,
    NSCompositeDestinationIn = 7,
    NSCompositeDestinationOut = 8,
    NSCompositeDestinationAtop = 9,
    NSCompositeXOR = 10,
    NSCompositePlusDarker = 11,
    NSCompositeHighlight = 12,
    NSCompositePlusLighter = 13
}

enum NSWindowOrderingMode
{
    NSWindowAbove = 1,
    NSWindowBelow = -1,
    NSWindowOut = 0
}

enum NSFocusRingType
{
    NSFocusRingTypeDefault = 0,
    NSFocusRingTypeNone = 1,
    NSFocusRingTypeExterior = 2
}

enum NSBackingStoreType
{
    NSBackingStoreRetained     = 0,
    NSBackingStoreNonretained  = 1,
    NSBackingStoreBuffered     = 2
}



//NSGeometry.h
alias bindings.NSIntersectionRect NSIntersectionRect;



// NSGradient.h
enum NSGradientDrawingOptions : NSUInteger
{
    NSGradientDrawsBeforeStartingLocation = (1 << 0),
    NSGradientDrawsAfterEndingLocation = (1 << 1),
}



// NSGraphicsContext.h
enum NSImageInterpolation
{
    NSImageInterpolationDefault,
    NSImageInterpolationNone,
    NSImageInterpolationLow,
    NSImageInterpolationHigh
} 



// NSHFSFileTypes.h
alias bindings.NSFileTypeForHFSTypeCode NSFileTypeForHFSTypeCode;



//IKPictureTaker.h
alias c_long NSInteger;
alias c_ulong NSUInteger;



// NSImage.h
enum NSImageCacheMode
{
    NSImageCacheDefault,
    NSImageCacheAlways,
    NSImageCacheBySize,
    NSImageCacheNever
}



// NSImageCell.h
enum NSImageAlignment
{
    NSImageAlignCenter = 0,
    NSImageAlignTop,
    NSImageAlignTopLeft,
    NSImageAlignTopRight,
    NSImageAlignLeft,
    NSImageAlignBottom,
    NSImageAlignBottomLeft,
    NSImageAlignBottomRight,
    NSImageAlignRight
}



// NSBitmapImageRep.h
enum NSTIFFCompression : NSUInteger {
    NSTIFFCompressionNone = 1,
    NSTIFFCompressionCCITTFAX3 = 3,
    NSTIFFCompressionCCITTFAX4 = 4,
    NSTIFFCompressionLZW = 5,
    NSTIFFCompressionJPEG = 6,
    NSTIFFCompressionNEXT = 32766,
    NSTIFFCompressionPackBits = 32773,
    NSTIFFCompressionOldJPEG = 32865
}

enum NSBitmapFormat : NSUInteger {
    NSAlphaFirstBitmapFormat = 1 << 0,
    NSAlphaNonpremultipliedBitmapFormat = 1 << 1,
    NSFloatingPointSamplesBitmapFormat = 1 << 2
}



// NSObjCRuntime.h
alias bindings.NSGetSizeAndAlignment NSGetSizeAndAlignment;

enum 
{
    NSNotFound = 0x7fffffff
}



// NSOpenGL.h
enum NSOpenGLPixelFormatAttribute : uint
{
    NSOpenGLPFAAllRenderers = 1,
    NSOpenGLPFADoubleBuffer = 5,
    NSOpenGLPFAStereo = 6,
    NSOpenGLPFAAuxBuffers = 7,
    NSOpenGLPFAColorSize = 8,
    NSOpenGLPFAAlphaSize = 11,
    NSOpenGLPFADepthSize = 12,
    NSOpenGLPFAStencilSize = 13,
    NSOpenGLPFAAccumSize = 14,
    NSOpenGLPFAMinimumPolicy = 51,
    NSOpenGLPFAMaximumPolicy = 52,
    NSOpenGLPFAOffScreen = 53,
    NSOpenGLPFAFullScreen = 54,
    NSOpenGLPFASampleBuffers = 55,
    NSOpenGLPFASamples = 56,
    NSOpenGLPFAAuxDepthStencil = 57,
    NSOpenGLPFAColorFloat = 58,
    NSOpenGLPFAMultisample = 59,
    NSOpenGLPFASupersample = 60,
    NSOpenGLPFASampleAlpha = 61,
    NSOpenGLPFARendererID = 70,
    NSOpenGLPFASingleRenderer = 71,
    NSOpenGLPFANoRecovery = 72,
    NSOpenGLPFAAccelerated = 73,
    NSOpenGLPFAClosestPolicy = 74,
    NSOpenGLPFARobust = 75,
    NSOpenGLPFABackingStore = 76,
    NSOpenGLPFAMPSafe = 78,
    NSOpenGLPFAWindow = 80,
    NSOpenGLPFAMultiScreen = 81,
    NSOpenGLPFACompliant = 83,
    NSOpenGLPFAScreenMask = 84,
    NSOpenGLPFAPixelBuffer = 90,
    NSOpenGLPFAAllowOfflineRenderers = 96,
    NSOpenGLPFAVirtualScreenCount = 128
}



// NSParagraphStyle.h
enum NSLineBreakMode 
{
    NSLineBreakByWordWrapping = 0,
    NSLineBreakByCharWrapping,
    NSLineBreakByClipping,
    NSLineBreakByTruncatingHead,
    NSLineBreakByTruncatingTail,
    NSLineBreakByTruncatingMiddle
}

enum NSTextTabType
{
    NSLeftTabStopType = 0,
    NSRightTabStopType,
    NSCenterTabStopType,
    NSDecimalTabStopType
}



// NSPathUtilities.h 
alias bindings.NSSearchPathForDirectoriesInDomains NSSearchPathForDirectoriesInDomains;
alias bindings.NSTemporaryDirectory NSTemporaryDirectory;



// NSText.h
enum NSTextAlignment
{
    NSLeftTextAlignment = 0,
    NSRightTextAlignment = 1,
    NSCenterTextAlignment = 2,
    NSJustifiedTextAlignment = 3,
    NSNaturalTextAlignment = 4
}



// NSWindow.h
enum : NSUInteger
{
    NSBorderlessWindowMask = 0,
    NSTitledWindowMask = 1 << 0,
    NSClosableWindowMask = 1 << 1,
    NSMiniaturizableWindowMask = 1 << 2,
    NSResizableWindowMask = 1 << 3,
    NSTexturedBackgroundWindowMask = 1 << 8
}



// NSZone.h
alias void* _NSZone;
alias _NSZone NSZone;